--[[
	DeathRun - IdlerEliminator
	for CS2D
	by Bolt_PL (USGN#88318)
	Enjoy, but don't steal! (stealing 5 minutes work it's a nonsense)
]]--
function distance(x1,y1,x2,y2)
     return math.floor(math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)))
end

function array(m,v)
	local tbl = {}
	for i = 1, m do
		tbl[i]=v
	end
	return tbl
end

dr={}
dr.killtime=10				--time every last player is killed

dr.time=dr.killtime
dr.dist=array(32,0)
dr.x=array(32,0)
dr.y=array(32,0)
parse("sv_gamemode 0")				--standard gamemode
parse("mp_damagefactor 0")			--no damage


addhook("move","dr.move")
function dr.move(id,x,y)
	dr.dist[id]=dr.dist[id]+distance(dr.x[id],dr.y[id],x,y)
	dr.x[id]=x
	dr.y[id]=y
	parse('hudtxt2 '..id..' 2 "000255000Distance:'..math.floor(dr.dist[id]/32)..'" 100 112')
end
addhook("movetile","dr.tile")
function dr.tile(id,x,y)
	if entity(x,y,"name")=="distance_premium" then
		dr.dist[id]=dr.dist[id]+10
		msg("000255000Lap bonus!@C")
	end
end
addhook("second","dr.timer")
function dr.timer()
	dr.time=dr.time-1
	parse('hudtxt 1 "255000000Time to next eliminate:'..dr.time..'" 100 100')
	if dr.time==0 then
		dr.eliminate() 
		dr.time=dr.killtime
	end
end
function dr.eliminate()
	local last=0
	for _,i in pairs(player(0,"tableliving")) do
		if last>0 then
			if dr.dist[i]<=dr.dist[last] then
				last=i
			end
		else
			last=i
		end	
	end
	msg("255000000"..player(last,"name").." has been eliminated!(distance:"..math.floor(dr.dist[last]/32)..")@C")
	parse("customkill "..last.." died "..last.."")
	parse('sv_sound "player/dominate.wav"')
	if #player(0,"tableliving")==1 then
		if player(player(0,"tableliving")[1],"team")==1 then
			msg("255000000Terrorists win!")
			parse('sv_sound "radio/terwin.ogg"')
		elseif player(player(0,"tableliving")[1],"team")==2 then
			msg("000000255Counter-terrorist win!")
			parse('sv_sound "radio/ctwin.ogg"')
		end
		parse("restartround")
	end
end

addhook("startround","dr.start")
function dr.start()
	dr.time=dr.killtime
	msg("255000000Run!@C")
end

addhook("spawn","dr.spawn")
function dr.spawn(id)
	dr.dist[id]=0
	dr.x[id]=0
	dr.y[id]=0
end